#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <values.h>

float huge x[10000], huge y[10000];
int huge px[20000], huge py[20000];
float min,x1,y1,x2,y2;
int n;

void ReadData(void) {
   FILE *f=fopen("POINTS.IN","rt");
   fscanf(f,"%d",&n);
   for (int i=0;i<n;i++)
      fscanf(f,"%f%f",&x[i],&y[i]);
}

void SortX(int left,int right) {
   int i=left,
       j=right,
       k=x[px[(left+right)/2]];

   float aux;
   do {
      while (x[px[i]]<k)
	 i++;
      while (x[px[j]]>k)
	 j--;
      if (i<=j) {
	 aux=px[i];
	 px[i]=px[j];
	 i++; j--;
      }
   } while (i<=j);
   if (j>=left)
      SortX(left,j);
   if (i<right)
      SortX(i,right);
}

void SortY(int left,int right) {
   int i=left,
       j=right,
       k=y[py[(left+right)/2]];

   float aux;
   do {
      while (y[py[i]]<k)
	 i++;
      while (y[py[j]]>k)
	 j--;
      if (i<=j) {
	 aux=py[i];
	 py[i]=py[j];
	 i++; j--;
      }
   } while (i<=j);
   if (j>=left)
      SortY(left,j);
   if (i<right)
      SortY(i,right);
}

void SortData(void) {
   for (int i=0;i<n;i++)
      px[i]=py[i]=i;
   SortX(0,n-1);
   SortY(0,n-1);
   for (i=0;i<n-1;i++)
      if (x[px[i]]==x[px[i+1]] && y[px[i]]==y[px[i+1]]) {
      FILE *f=fopen("POINTS.OUT","wt");
      fprintf(f,"%.3f %.3f\n%.3f %.3f\n",x[px[i]],y[px[i]],x[px[i]],y[px[i]]);
      fclose(f); exit(0);
   }
}

inline float dist(int i,int j) {
return sqrt((x[py[i]]-x[py[j]])*(x[py[i]]-x[py[j]])+
	    (y[py[i]]-y[py[j]])*(y[py[i]]-y[py[j]]));
}

void DivideEtImpera (int i1,int j1,int i2,int j2) {

int i,j; float half;
if (j2-i2<3) {
   for (i=i2;i<=j2-1;i++)
      for (j=i+1;j<=j2;j++)
	 if (dist(i,j)<min) {
	 min=dist(i,j);
	 x1=x[py[i]];
	 y1=y[py[i]];
	 x2=x[py[j]];
	 y2=y[py[j]];
      }
   return;
}
half=x[px[(i1+j1)/2]];
j=0;
for (i=i2;i<=j2;i++)
  if (x[py[i]]<half)
     py[j2+(++j)]=py[i];
  if (j>1)
     DivideEtImpera(i1,i1+j-1,j2+1,j2+j);
  j=0;
  for (i=i2;i<=j2;i++)
     if (x[py[i]]>half)
	py[j2+(++j)]=py[i];;
  if (j>1)
     DivideEtImpera(j1-j+1,j1,j2+1,j2+j);
  j=0;
  for (i=i2;i<=j2;i++)
     if (fabs(x[py[i]]-half)<min)
	py[j2+(++j)]=py[i];
  for (i=j2+1;i<j2;i++)
     for (int m=i+1;m<i+8 && m<=j2+j;m++)
	if (dist(i,m)<min) {
	   min=dist(i,m);
	   x1=x[py[i]];
	   y1=y[py[i]];
	   x2=x[py[m]];
	   y2=y[py[m]];
	}
}

void Solve(void) {
   min=MAXFLOAT;
   DivideEtImpera(0,n-1,0,n-1);
}

void WriteSolution(void) {
    FILE *f=fopen("POINTS.OUT","wt");
    fprintf(f,"%.3f %.3f\n %.3f %.3f",x1,y1,x2,y2);
    fclose(f);
}

void main(void) {
   ReadData();
   SortData();
   Solve();
   WriteSolution();
}
