// Autor: Mihai Scortaru
// Copyright (c) 2002 Agora Media SRL
// Acest fisier este distribuit in regim freeware. 
// Nu este permisa modificarea codului sursa fara acordul autorului.
// Acest fisier nu poate fi folosit in scopuri comerciale fara acordul 
//   scris al SC Agora Media SRL.
// Acest fisier este distribuit "asa cum este"; autorul sau Agora Media SRL
//   nu pot fi responsabili pentru eventuale daune provocate direct sau
//   indirect de acest fisier.
// Programul a fost testat utilizand seturile de date folosite la finala 
//   Concursului International de Programare "Bursele Agora" si a functionat 
//   corect in toate aceste situatii.

#include <stdio.h>
#include <values.h>

#define INFINIT MAXLONG;

long x[1010], y[1010]; // coordonatele obiectivelor
long min[1010]; // distanta minima de la o benzinarie la un obiectiv aflat deja in APM (de fapt se pastreaza patratele distantelor)
int parinte[1010]; // parintii nodurilor in APM
int folosit[1010]; // sir care indica daca un nod a fost adaugat in arbore
int n,k,total; // numarul benzinariilor, rafinariilor, obiectivelor
int nr; // numarul nodurile care fac parte din APM la un moment dat

void CitesteDate(void){
  FILE *f=fopen("CONDUCTE.IN","rt");
  fscanf(f,"%d%d",&k,&n);
  total = k + n;
  for (int i = 0; i < total; i++)
    fscanf(f,"%ld%ld",&x[i],&y[i]);
}

void UnesteRafinarii(void){
  // legarea nodurilor care corespund rafinariilor
  for (int i=0;i<k;i++){
    min[i] = 0; // distanta de la o rafinarie la cea mai apropiata rafinarie este 0
    parinte[i] = 0; // sunt "legate" de prima rafinarie
    folosit[i] = 1; // fac deja parte din APM
  }
}

void DeterminaDistanteMinime(void){
  for (int i = k; i < total; i++){
    min[i] = INFINIT;
    for (int j = 0; j < k ;j++){
      long dist = (x[i]-x[j])*(x[i]-x[j])+(y[i]-y[j])*(y[i]-y[j]);
      if (dist < min[i]){
	min[i] = dist;
	parinte[i] = j;
      }
    }
  }
}

void ConstruiesteAPM(void){
  long dist = INFINIT;
  int benzinarie;
  // se alege cea mai apropiata benzinarie de o rafinarie
  for (int i = k; i<total; i++)
    if (min[i] < dist){
      dist = min[i];
      benzinarie = i;
    }
  folosit[benzinarie] = 1; // benzinaria este adaugata in arbore
  nr = k + 1; // in arbore sunt toate benzinariile si o rafinarie
  while (nr < total){ // cat timp nu toate nodurile fac parte din APM
    // se determina benzinaria care va fi adaugata in arbore
    for (i = k; i < total; i++)
      if (!folosit[i]){
	// eventuala actualizare a distantelor minime
	dist = (x[i]-x[benzinarie])*(x[i]-x[benzinarie])+(y[i]-y[benzinarie])*(y[i]-y[benzinarie]);
	if (dist < min[i]){
	  min[i] = dist;
	  parinte[i] = benzinarie;
	}
      }
    // se alege cea mai apropiata benzinarie fata de un obiectiv aflat deja in APM
    dist = INFINIT;
    for (int i = k; i < total; i++)
      if (!folosit[i] && (min[i] < dist)){
	benzinarie = i;
	dist = min[i];
      }
    folosit[benzinarie] = 1; // benzinaria face parte din APM
    nr++; // s-a mai adaugat un nod in APM
  }
}

void DeterminaSolutia(void){
  UnesteRafinarii();
  DeterminaDistanteMinime();
  ConstruiesteAPM();
}

void ScrieSolutia(void){
  FILE *f=fopen("CONDUCTE.OUT","wt");
  for (int i = k; i < total; i++)
    fprintf(f,"B%d %c%d\n", i - k + 1, // numarul benzinariei
			    (parinte[i] < k)?'R':'B', // tipul obiectivului de care este legata benzinaria
			    (parinte[i] < k)?parinte[i] + 1:parinte[i] - k + 1); // numarul de ordine al obiectivului de care este legata benzinaria
  fclose(f);
}

void main(void){
  CitesteDate();
  DeterminaSolutia();
  ScrieSolutia();
}