// Autor: Mihai Scortaru
// Copyright (c) 2002 Agora Media SRL
// Acest fisier este distribuit in regim freeware. 
// Nu este permisa modificarea codului sursa fara acordul autorului.
// Acest fisier nu poate fi folosit in scopuri comerciale fara acordul 
//   scris al SC Agora Media SRL.
// Acest fisier este distribuit "asa cum este"; autorul sau Agora Media SRL
//   nu pot fi responsabili pentru eventuale daune provocate direct sau
//   indirect de acest fisier.
// Programul a fost testat utilizand seturile de date folosite la ONI 2002 
//   si a functionat corect in toate aceste situatii.

#include <stdio.h>
#include "prog.h"

int N; // numarul de elemente ale permutarii
int NId; // numarul de elemente ale permutarii identice care se afla pe pozitiile corecte
int perm[256]; // permutarea folosita pentru apelul functiei Check
int sol[256]; // sir care indica daca s-au gasit pozitiile elementelor in permutarea corecta
	      // sol[i] = pozitia elementului i in permutarea corecta
int permsol[256]; // permutarea corecta

void PreiaDate(void){
  N = GetN();
}

void Initializare(void){
  for (int i=0;i<N;i++)
    perm[i] = i + 1; // initializare cu permutarea identica
  NId = Check(perm); // numarul de pozitii corecte in permutarea identica
}

void DeterminaPozitia(int elem){
  int nrImb = 0; // numarul interschimbarilor care duce la cresterea numarului de pozitii corecte
  int poz[2]; // pozitiile pe care sunt gasite imbunatatiri
  if (permsol[elem]) // se cunoaste deja o imbunatatire
    poz[nrImb++] = permsol[elem] - 1;
  for (int i=0;i<N && nrImb<2;i++)
    if (i!=elem && (!permsol[i] || !sol[i])){
      // interschimbare
      perm[elem] = perm[i];
      perm[i] = elem + 1;
      int nr = Check(perm);
      if (nr > NId)
	poz[nrImb++] = i;
      // refacerea permutarii identice
      perm[elem] = elem + 1;
      perm[i] = i + 1;
      if (abs(nr - NId) == 2) // sigur se afla sau ajung pe pozitia corecta
	break;
    }
  switch (nrImb){
    case 0: // elementul se afla pe pozitia corecta
      sol[elem] = 1;
      permsol[elem] = elem + 1;
      return;
    case 1: // printr-o interschimbare doua elemente au ajuns pe pozitiile corecte
      sol[elem] = sol[poz[0]] = 1;
      permsol[elem] = poz[0] + 1;
      permsol[poz[0]] = elem + 1;
      return;
    case 2: // trebuie identificata exact pozitia corecta
      // permutarea a trei elemente
      perm[elem] = poz[0] + 1;
      perm[poz[0]] = poz[1] + 1;
      perm[poz[1]] = elem + 1;
      int nr = Check(perm);
      int x = (nr-NId>1)?0:1; // determina pe care pozitie ajunge eleemntul curent
      sol[elem] = sol[poz[x]] = 1;
      permsol[elem] = poz[x] + 1;
      permsol[poz[1-x]] = elem + 1;
      // refacerea permutarii identice
      perm[elem] = elem + 1;
      perm[poz[0]] = poz[0] + 1;
      perm[poz[1]] = poz[1] + 1;
      return;
  }
}

void DeterminaSolutia(void){
  Initializare();
  for (int i=0;i<N;i++)
    if (!sol[i])
      DeterminaPozitia(i);
}

void ScrieSolutia(void){
  FILE *f = fopen("DECOD.OUT","wt");
  fprintf(f,"%d",permsol[0]);
  for (int i=1;i<N;i++)
    fprintf(f," %d",permsol[i]);
  fclose(f);
}

void main(void){
  PreiaDate();
  DeterminaSolutia();
  ScrieSolutia();
}