// Autor: Mihai Scortaru
// Copyright (c) 2002 Agora Media SRL
// Acest fisier este distribuit in regim freeware. 
// Nu este permisa modificarea codului sursa fara acordul autorului.
// Acest fisier nu poate fi folosit in scopuri comerciale fara acordul 
//   scris al SC Agora Media SRL.
// Acest fisier este distribuit "asa cum este"; autorul sau Agora Media SRL
//   nu pot fi responsabili pentru eventuale daune provocate direct sau
//   indirect de acest fisier.
// Programul a fost testat utilizand seturile de date folosite la finala 
//   Concursului International de Programare "Bursele Agora" si a functionat 
//   corect in toate aceste situatii.

#include <stdio.h>
#include <string.h>

char cod[100][100]; // reperele
char s1[100],s2[100];
int m,n; // numarul de repere si de drumuri
int pred[100][100]; // matrice care pastreaza predecesorii reperelor (reperele din care se poate ajunge la un anumit reper)
int nr[100]; // numarul predecesorilor unui reper
long sol[100]; // numarul de posibilitati de ajungere la un reper

int Cod(char *s){
  // determina codul unui reper
  for (int i=0;i<n;i++)
    if (!strcmp(s,cod[i]))
      return i;
  // daca nu a fost gasit reperul, este adaugat
  strcpy(cod[n++],s);
  return n-1;
}

void CitesteDate(void){
  FILE *f=fopen("SAM.IN","rt");
  fscanf(f,"%d",&m);
  n = 0;
  for (int i=0;i<m;i++){
    fscanf(f,"%s%s",s1,s2);
    int x = Cod(s1);
    int y = Cod(s2);
    pred[y][nr[y]++] = x;
  }
}

long ok(int k){
  long valoare = 0;
  // se verifica daca a fost determinat numarul posibilitatilor pentru predecesorii reperului curent
  for (int j = 0;j<nr[k];j++)
    if (!sol[pred[k][j]])
      return 0;
    else valoare += sol[pred[k][j]];
  // pe parcursul verificarii se determina si numarul posibilitatilor de ajungere la reperul curent
  return valoare;
}

void DeterminaSolutia(void){
  // exista o posibilitate de ajungere in VALCEAUADESPICATA
  sol[Cod("VALCEAUADESPICATA")] = 1;
  int schimbare;
  long valoare;
  do{
    schimbare = 0;
    for (int i=0;i<n;i++)
      if (!sol[i]) // daca numarul posibilitatilor de ajungere la acest reper nu a fost determinat
	if (valoare=ok(i)){
	  sol[i] = valoare;
	  schimbare = 1; // a fost determinat numarul de posibilitati pentru un nou reper
	}
  } while (schimbare); // pana cand nu se realizeaza o noua determinare
}

void ScrieSolutia(void){
  FILE *f = fopen("SAM.OUT","wt");
  // se cauta numarul posibilitatilor de ajungere in MUNTELEOSANDEI
  fprintf(f,"%ld",sol[Cod("MUNTELEOSANDEI")]);
  fclose(f);
}

void main(void){
  CitesteDate();
  DeterminaSolutia();
  ScrieSolutia();
}