// Autor: Mugurel-Ionut Andreica
// Acest fisier este distribuit in regim freeware si a fost inclus in       
//   CD-ul de prezentare a solutiilor problemelor de la ONI 2002            
// Acest fisier a fost folosit pentru evaluarea solutiilor concurentilor    
//   la problema DECOD propusa spre rezolvare la ONI 2002                   
// Nu este permisa modificarea codului sursa fara acordul autorului.
// Acest fisier este distribuit "asa cum este"; autorul sau Agora Media SRL
//   nu pot fi responsabili pentru eventuale daune provocate direct sau
//   indirect de acest fisier.

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int mod_p[512];
int mod_n = 0;

void mod_exitprog(char *s)
{
	printf("%s\n", s);
	exit(1);
}

int GetN(void)
{
	int i, nt;
	FILE *f;
	char used[256];
	f = fopen("decod.in", "r");
	memset(used, 0, sizeof(used));
	fscanf(f, "%d", &mod_n);
	if((unsigned) (mod_n - 1) > 255)
		mod_exitprog("Valoarea lui N este in afara limitelor specificate");
	for(i = 0; i < mod_n; i++) {
		int x;

		fscanf(f, "%d", &x);
		if(((unsigned) (x - 1) >= mod_n) || (used[x - 1]++))
			mod_exitprog("Sirul din fisierul de intrare nu este permutare");
		mod_p[i * 2] = i + 1;
		mod_p[i * 2 + 1] = (x ^ 67) + 33;
	}
	fclose(f);
	return(mod_n);
}

int Check(int p[])
{
	char used[256];
	int i, np = 0;

	memset(used, 0, sizeof(used));
	for(i = 0; i < mod_n; i++) {
		if(((unsigned) (p[i] - 1) >= mod_n) || (used[p[i] - 1]++))
			return(-1);
		if(p[i] == ((mod_p[i * 2 + 1] - 33) ^ 67))
			np++;
	}
	return(np);
}
