// Autor: Mihai Scortaru
// Copyright (c) 2002 Agora Media SRL
// Acest fisier este distribuit in regim freeware. 
// Nu este permisa modificarea codului sursa fara acordul autorului.
// Acest fisier nu poate fi folosit in scopuri comerciale fara acordul 
//   scris al SC Agora Media SRL.
// Acest fisier este distribuit "asa cum este"; autorul sau Agora Media SRL
//   nu pot fi responsabili pentru eventuale daune provocate direct sau
//   indirect de acest fisier.
// Programul a fost testat utilizand seturile de date folosite la ONI 2002 
//   si a functionat corect in toate aceste situatii.

#include <stdio.h>
#include <string.h>
#include <alloc.h>

#define DIM_TEXT 32768L

int M, N;
char far *text[4];
int far *textSortat[4], *textSortatTmp;
char buf[32768]; // buffer de intrare/iesire
int nrBlocuri;
unsigned lungimeText[4];
unsigned nrCuvinte[53];
unsigned pozitii[53];
FILE *f, *g;

void CitesteDate(void){
  char linie[100];
  FILE *f=fopen("SETI.IN","rt");
  setvbuf(f, buf, _IOFBF, 0x4000);
  fscanf(f, "%d\n", &N);
  for (unsigned i=0;i<4;i++)
    text[i] = (char far*)farmalloc(DIM_TEXT);
  for(i = 0; i < N; i++) {
    fgets(linie, sizeof(linie), f);
    _fmemcpy(text[i / 512] + ((i&511) << 6), linie, 64);
  }
  _fmemcpy(text[i / 512] + ((i&511) << 6), "{{{{{{{{{{{{{{{{", 16);
  nrBlocuri = (i-1)/512 + 1;
  fclose(f);
}

void NumaraCuvinte(int k, unsigned poz, unsigned lungime){
  for (unsigned i=0;i<53;i++)
    nrCuvinte[i] = 0;
  for (i=0;i<lungime;i++){
    char c = text[k][i+poz];
    nrCuvinte[(c>'Z')?c-'a'+26:c-'A']++;
  }
}

void DeterminaPozitii(void){
  pozitii[0] = 0;
  for (unsigned i=1;i<53;i++)
    pozitii[i] = pozitii[i-1] + nrCuvinte[i-1];
}

void ModificaOrdinea(int k, unsigned poz, unsigned lungime){
  for (unsigned i = 0;i<lungime;i++){
    char c = text[k][textSortat[k][i]+poz];
    unsigned ind = (c>'Z')?c-'a'+26:c-'A';
    textSortatTmp[pozitii[ind]++] = textSortat[k][i];
  }
  _fmemcpy(textSortat[k],textSortatTmp,lungime*2);
}

void SorteazaBloc(int k){
  // sorteaza un bloc folosind algoritmul RadixSort
  // textsortat[k][i] = al i-lea cuvant de 16 litere in blocul k
  textSortat[k] = (int far*) farmalloc(2 * DIM_TEXT - 30);
  textSortatTmp = (int far*) farmalloc(2 * DIM_TEXT - 30);
  unsigned lungime = lungimeText[k] - 15;
  for (unsigned i=0;i<lungime;i++)
    textSortat[k][i] = i;
  for (int poz=15;poz>=0;poz--){
    // sortare dupa pozitia poz a cuvantului (a poz-a litera)
    NumaraCuvinte(k,poz,lungime);
    DeterminaPozitii();
    ModificaOrdinea(k,poz,lungime);
  }
  farfree(textSortatTmp);
}

void SorteazaDate(void){
  for (int i=0;i<nrBlocuri;i++)
    SorteazaBloc(i);
}

void PregatesteBlocuri(void){
  // ultimele 15 caractere dintr-un bloc sunt primele 15 in urmatorul
  for (int i=0;i<nrBlocuri - 1; i++)
    lungimeText[i] = DIM_TEXT;
  lungimeText[nrBlocuri - 1] = (N % 512) * 64 + 16;
  char far *textTmp = (char far*)farmalloc(DIM_TEXT); // bloc temporar
  for (i=3;i;i--){
    if ((long)lungimeText[i-1] + i * 15 > (long)DIM_TEXT){
      // ultimele caractere din blocul anterior
      _fmemcpy(textTmp,text[i-1] + DIM_TEXT - i * 15, i * 15);
      // eliminarea ultimelor caractere din blocul curent
      _fmemcpy(textTmp + i * 15, text[i], DIM_TEXT - i * 15);
      _fmemcpy(text[i],textTmp,DIM_TEXT);
      lungimeText[i] += i*15;
      if (lungimeText[i] > DIM_TEXT)
	lungimeText[i] = DIM_TEXT;
    }
  }
  farfree(textTmp);
}

int Compara(int bloc, char *cuv, int poz){
  int lungimeCuvant = strlen(cuv);
  for (unsigned i = 0;i<lungimeCuvant;i++){
    char c = text[bloc][textSortat[bloc][poz]+i];
    if (cuv[i] > c)
      return 1;
    else
      if (cuv[i] < c)
	return -1;
  }
  return 0;
}

unsigned NumarAparitiiBloc(char *cuv, int bloc){
  int lungime = lungimeText[bloc] - 15;
  if (lungime < 0) // blocul nu exista
    return 0;
  long x = 0, y = lungime-1 , mijloc, min = lungime, max = 0;
  // se determina ultima aparitie
  while (x <= y){
    mijloc = (x + y) / 2;
    int comp = Compara(bloc,cuv,mijloc);
    if (!comp)
      if (mijloc > max)
	max = mijloc;
    if (comp >= 0)
      x = mijloc + 1;
    else
      y = mijloc - 1;
  }
  // se determina prima aparitie
  x = 0;
  y = lungime-1;
  while (x <= y){
    mijloc = (x + y) / 2;
    int comp = Compara(bloc,cuv,mijloc);
    if (!comp)
      if (mijloc < min)
	min = mijloc;
    if (comp <= 0)
      y = mijloc - 1;
    else
      x = mijloc + 1;
  }
  return (max - min + 1 >0)?max - min + 1: 0;
}

unsigned NumarAparitii(char *cuv){
  unsigned total = 0;
  for (int i = 0; i < 4;i++)
    total+=NumarAparitiiBloc(cuv, i);
  return total;
}

void DeterminaSolutia(void){
  char cuvant[20];
  PregatesteBlocuri();
  SorteazaDate();
  f=fopen("DIC.IN","rt");
  g=fopen("SETI.OUT","wt");
  setvbuf(f, buf, _IOFBF, 0x4000);
  setvbuf(g, buf + 0x4000, _IOFBF, 0x4000);
  fscanf(f,"%d\n",&M);
  for (int i = 0;i<M;i++){
    fgets(cuvant,20,f);
    cuvant[strlen(cuvant)-1] = 0;
    if (strlen(cuvant))
      fprintf(g,"%u\n",NumarAparitii(cuvant));
    else
      fprintf(g,"%ld\n",(long)N*64);
  }
  fclose(f);
  fclose(g);
}

void main(void){
  CitesteDate();
  DeterminaSolutia();
}