// Autor: Mihai Scortaru
// Copyright (c) 2002 Agora Media SRL
// Acest fisier este distribuit in regim freeware. 
// Nu este permisa modificarea codului sursa fara acordul autorului.
// Acest fisier nu poate fi folosit in scopuri comerciale fara acordul 
//   scris al SC Agora Media SRL.
// Acest fisier este distribuit "asa cum este"; autorul sau Agora Media SRL
//   nu pot fi responsabili pentru eventuale daune provocate direct sau
//   indirect de acest fisier.
// Programul a fost testat utilizand seturile de date folosite la ONI 2002 
//   si a functionat corect in toate aceste situatii.

#include <stdio.h>

typedef int NumarMare[101]; // folosim baza 10000;
			    // primul element corespunde numarului de cifre
int N;
NumarMare Nr[101],Suma,Aux;
int factori[100];

void CitesteDate(void){
  FILE *f=fopen("SISTEM.IN","rt");
  fscanf(f,"%d",&N);
  fclose(f);
}

void DeterminaFactori(int k,int n){
  // C(n-1,k-1) * (k-1)!/2 = (n-1)!/((k-1)!*(n-k)!) * (k-1)!/2
  //                       = (n-1)!/(n-k)!/2
  for (int i = n-k+1;i<n;i++)
    factori[i-n+k-1] = i;
  factori[(factori[0]&1)?1:0]/=2; // factori[0] sau factori[1] se imparte la 2 (unul este cu siguranta par)
}

void AtribuieAux(int k){
  // Aux = Nr(k);
  for (int i=0;i<=Nr[k][0];i++)
    Aux[i] = Nr[k][i];
  for (int j = i; j<=100; j++)
    Aux[j] = 0;
}

void AtribuieNr(int k){
  // Aux = Nr(k);
  for (int i=0;i<=Suma[0];i++)
    Nr[k][i] = Suma[i];
}

void Inmultire(int n){
  // Aux = Aux * n
  long transport=0, cifra;
  for (int i=1;i<=Aux[0];i++){
    cifra = ((long)Aux[i] * n + transport) % 10000;
    transport = ((long)Aux[i] * n + transport) / 10000;
    Aux[i] = cifra;
  }
  while (transport){
    Aux[++Aux[0]] = transport % 10000;
    transport /= 10000;
  }
}

void InmultireFactori(int n){
  // Aux = Aux * factori[0] * ... * factori[n]
  for (int i = 0; i<n;i++)
    Inmultire(factori[i]);
}

void Adunare(void){
  // Suma = Suma + Aux;
  int max = (Suma[0]>Aux[0])?Suma[0]:Aux[0];
  long cifra, transport=0;
  Suma[0] = max;
  for (int i=1;i<=max;i++){
    cifra = (Suma[i] + Aux[i] + transport) % 10000;
    transport = (Suma[i] + Aux[i] + transport) / 10000;
    Suma[i] = cifra;
  }
  if (transport){
    Suma[++Suma[0]] = transport;
  }
}

void CalculeazaValoarea(int n){
  // Nr(n) = Suma(Nr(n-k)*C(n-1,k-1)*(k-1)!/2); k = 3,...,n; C(i,j) = combinari de i luate cate j
  Suma[0]=1; // Suma = 0
  for (int i=1;i<100;i++)
    Suma[i] = 0;
  for (int k = 3; k<=n; k++){
    DeterminaFactori(k,n);
    AtribuieAux(n-k); // Aux = Nr[n-k]
    InmultireFactori(k-1);
    Adunare(); // Suma = Suma + Aux;
  }
  AtribuieNr(n); // Nr[n] = Suma;
}

void DeterminaSolutia(void){
  Nr[0][0]=Nr[0][1]=1; 	// Nr[0] = 1;
  Nr[1][0]=1; 		// Nr[1] = 0;
  Nr[2][0]=1; 		// Nr[2] = 0;
  for (int i=3;i<=N;i++)
    CalculeazaValoarea(i);
}

void ScrieSolutia(void){
  FILE *f=fopen("SISTEM.OUT","wt");
  fprintf(f,"%d",Nr[N][Nr[N][0]]); // se scrie prima cifra (in baza 10000);
  for (int i = Nr[N][0] - 1; i;i--)
    fprintf(f,"%04d",Nr[N][i]); // se scriu celelalte cifre (in baza 10000);
  fclose(f);
}

void main(void){
  CitesteDate();
  DeterminaSolutia();
  ScrieSolutia();
}